This is an extension and not part of the main GoJS library. Note that the API for this class may change at any time. If you intend to use an extension in production, you should copy the code to your own source directory. Extensions can be found in the GoJS kit under the `extensions` or `extensionsTS` folders. See the Extensions intro page for more information.

### Hierarchy

- Layout
  - TreeLayout
    - FishboneLayout

FishboneLayout is a custom Layout derived from TreeLayout for creating "fishbone" diagrams. A fishbone diagram also requires a Link class that implements custom routing, FishboneLink.

This only works for angle === 0 or angle === 180.

This layout assumes Links are automatically routed in the way needed by fishbone diagrams, by using the FishboneLink class instead of go.Link.

If you want to experiment with this extension, try the Fishbone Layout sample.

## Index

### Constructors

- constructor

### Methods

- assignTreeVertexValues
- commitLinks
- commitNodes
- makeNetwork
- shift
- shiftAll

## Constructors

### constructor

- new FishboneLayout(): FishboneLayout

- Constructs a FishboneLayout and sets the following properties:

  - alignment = TreeLayout.AlignmentBusBranching
  - setsPortSpot = false
  - setsChildPortSpot = false

  #### Returns FishboneLayout

## Methods

### Override assignTreeVertexValues

- assignTreeVertexValues(v: TreeVertex): void

- Add a direction property to each vertex and modify TreeVertex.layerSpacing.

  #### Parameters

  - ##### v: TreeVertex

  #### Returns void

### Override commitLinks

- commitLinks(): void

- This override stops links from being committed since the work is done by the FishboneLink class.

  #### Returns void

### Override commitNodes

- commitNodes(): void

- Assigns Link.fromSpots and Link.toSpots based on branching and angle and moves vertexes based on dummy locations.

  #### Returns void

### Override makeNetwork

- makeNetwork(coll: Diagram | Group | Iterable<Part>): LayoutNetwork

- Create and initialize a LayoutNetwork with the given nodes and links. This override creates dummy vertexes, when necessary, to allow for proper positioning within the fishbone.

  #### Parameters

  - ##### coll: Diagram | Group | Iterable<Part>

    A Diagram or a Group or a collection of Parts.

  #### Returns LayoutNetwork

### shift

- shift(v: TreeVertex): void

- Shifts subtrees within the fishbone based on angle and node spacing.

  #### Parameters

  - ##### v: TreeVertex

  #### Returns void

### shiftAll

- shiftAll(direction: number, absolute: number, root: TreeVertex, v: TreeVertex): void

- Shifts a subtree.

  #### Parameters

  - ##### direction: number

  - ##### absolute: number

  - ##### root: TreeVertex

  - ##### v: TreeVertex

  #### Returns void

Copyright © 1998-2019 by Northwoods Software Corporation.